// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from gps_msgs:msg/GPSFix.idl
// generated code does not contain a copyright notice

#ifndef GPS_MSGS__MSG__DETAIL__GPS_FIX__FUNCTIONS_H_
#define GPS_MSGS__MSG__DETAIL__GPS_FIX__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "gps_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "gps_msgs/msg/detail/gps_fix__struct.h"

/// Initialize msg/GPSFix message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * gps_msgs__msg__GPSFix
 * )) before or use
 * gps_msgs__msg__GPSFix__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_gps_msgs
bool
gps_msgs__msg__GPSFix__init(gps_msgs__msg__GPSFix * msg);

/// Finalize msg/GPSFix message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_gps_msgs
void
gps_msgs__msg__GPSFix__fini(gps_msgs__msg__GPSFix * msg);

/// Create msg/GPSFix message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * gps_msgs__msg__GPSFix__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_gps_msgs
gps_msgs__msg__GPSFix *
gps_msgs__msg__GPSFix__create();

/// Destroy msg/GPSFix message.
/**
 * It calls
 * gps_msgs__msg__GPSFix__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_gps_msgs
void
gps_msgs__msg__GPSFix__destroy(gps_msgs__msg__GPSFix * msg);


/// Initialize array of msg/GPSFix messages.
/**
 * It allocates the memory for the number of elements and calls
 * gps_msgs__msg__GPSFix__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_gps_msgs
bool
gps_msgs__msg__GPSFix__Sequence__init(gps_msgs__msg__GPSFix__Sequence * array, size_t size);

/// Finalize array of msg/GPSFix messages.
/**
 * It calls
 * gps_msgs__msg__GPSFix__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_gps_msgs
void
gps_msgs__msg__GPSFix__Sequence__fini(gps_msgs__msg__GPSFix__Sequence * array);

/// Create array of msg/GPSFix messages.
/**
 * It allocates the memory for the array and calls
 * gps_msgs__msg__GPSFix__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_gps_msgs
gps_msgs__msg__GPSFix__Sequence *
gps_msgs__msg__GPSFix__Sequence__create(size_t size);

/// Destroy array of msg/GPSFix messages.
/**
 * It calls
 * gps_msgs__msg__GPSFix__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_gps_msgs
void
gps_msgs__msg__GPSFix__Sequence__destroy(gps_msgs__msg__GPSFix__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // GPS_MSGS__MSG__DETAIL__GPS_FIX__FUNCTIONS_H_
